
/**
 * Copyright 2012 Clint Combs
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.newhart.example

import org.newhart._
import org.newhart.mongodb.AuditStore
import java.util.{Date => JDate}
import com.mongodb.casbah.MongoConnection

object AuditUsers extends App {
  implicit val con = MongoConnection("localhost")
  implicit val store = new AuditStore()
  store.createAudit("users", 10000)

  val loginNames = NameLoader.firstNames

  /*
  val auditor = audit("users").from("org.newhart.example.AuditUsers").ofType("User")

  val createAuditor = auditor.snap.labeled("security").labeled("create")
  val loginAuditor = auditor.snap.labeled("security").labeled("authenticate")
  val failedLoginAuditor = auditor.snap.labeled("security").labeled("authenticate").labeled("failed")
  val emailChangeAuditor = auditor.snap.withoutLabels().labeled("email")

  println(createAuditor)
  println(loginAuditor)
  println(failedLoginAuditor)
  println(emailChangeAuditor)

  var ts = System.currentTimeMillis
  loginNames.foreach { loginName =>
    val now = new JDate()
    createAuditor.withMsg("new user created: " + loginName).
      //withData("loginName", Value(loginName)).
      withKey(loginName+"-create-"+ts).withCreateAndUpdate(now).asMajor.go
    ts = ts + 1
  }

  loginNames.foreach { loginName =>
    val now = new JDate()
    loginAuditor.withMsg("successful login: " + loginName).
      //withData("loginName", Value(loginName)).
      withKey(loginName+"-authenticate-"+ts).withCreateAndUpdate(now).asMajor.go
    ts = ts + 1
  }

  loginNames.foreach { loginName =>
    val now = new JDate()
    failedLoginAuditor.withMsg("login failed: " + loginName).
      //withData("loginName", Value(loginName)).
      withError(Error(msg=Some("invalid password"), code=Some("auth001"))).
      withKey(loginName+"-authenticate-failed-"+ts).
      withCreateAndUpdate(now).asMajor.go
    ts = ts + 1
  }

  loginNames.foreach { loginName =>
    val now = new JDate()
    emailChangeAuditor.withMsg("user '" + loginName + "' updated e-mail address from '" +
      loginName + "@gmail.com'" + " to '" + loginName + "@yahoo.com'").
      //withData("loginName", Value(loginName)).
      withKey(loginName+"-email-update-"+ts).withCreateAndUpdate(now).asMinor.go
  }
  */

  con.close
}

object NameLoader {
  def firstNames:List[String] = {
    loadFirstNames
  }

  def loadFirstNames:List[String] = {
    val filename = "/users/Clint/Downloads/census.gov/names/dist.female.first.txt"
    var list = List[String]()
    for(line <- scala.io.Source.fromFile(filename).getLines) {
      val trimmedLine = line.trim
      val spaceIndex = line.indexOf(' ')

      if ((trimmedLine.length > 0) && (spaceIndex > 0)) list = line.substring(0, spaceIndex).toLowerCase + "2012" :: list
    }

    list.reverse
  }
}
